; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL cnt   :DWORD
    LOCAL drv   :DWORD

    LOCAL avl   :QWORD
    LOCAL dsk   :QWORD
    LOCAL fre   :QWORD

    LOCAL pbuf  :DWORD
    LOCAL buffer[16]:BYTE

    LOCAL dvd   :DWORD
    LOCAL rsl   :DWORD

    push ebx
    push esi
    push edi

    mov dvd, 1024 * 1024 * 1024     ; divider is 1 gigabyte

    mov cnt, 0                      ; zero the counter
    mov drv, "A"                    ; start at drive A

    lea ebx, drv                    ; load address of variable "drv" into EBX

    invoke GetLogicalDrives         ; returns bitmask in EAX
    mov esi, eax
    mov edi, 00000000000000000000000000000001b

    print "drv",9,9,"disk",9,9,"free",13,10
    print "===",9,9,"====",9,9,"====",13,10

  ; -----------------------------------------------------------------------

  lp:
    test esi, edi                   ; test if bit set in ESI
    jz @F

    mov pbuf, ptr$(buffer)
    mov pbuf, cat$(pbuf,ebx,":\")   ; append ":\" to the drive letter

    invoke GetDiskFreeSpaceEx,pbuf,ADDR avl,ADDR dsk,NULL
    push eax

    print pbuf,9,9

    pop eax
    .if eax != 0
      fild dsk                      ; load source
      fild dvd                      ; load divider
      fdiv                          ; divide source by divider
      fistp rsl                     ; store result in variable
      print str$(rsl)," gb",9,9
    .else
      print "---",9,9
      print "---",9,9,13,10
      jmp @F
    .endif

      fild avl                      ; load source
      fild dvd                      ; load divider
      fdiv                          ; divide source by divider
      fistp rsl                     ; store result in variable
  
      print str$(rsl)," gb",13,10

  @@:
    rol edi, 1                      ; shift bit left to test next drive

    add cnt, 1                      ; increment counter
    add drv, 1                      ; increment drive

    cmp cnt, 26                     ; loop through all possibilities
    jne lp

  ; -----------------------------------------------------------------------

    pop edi
    pop esi
    pop ebx

    ret

main endp

; 

end start
